import java.util.*;

class BlocF {
    public int parametreN;
    public int adresseDeRetour;
    public int valeurDeRetour;
    BlocF(int ar, int n) {
	adresseDeRetour = ar;
	parametreN = n;
	valeurDeRetour = -1;
    }
    public String toString() {
	return "{n="+parametreN+",retour="+adresseDeRetour+",valeur="+valeurDeRetour+"}";
    }
}

public class EX8_1 {
    public static void main(String []a) {
	boolean fin = false;
	int instruction = -2;
	int x=0;
	Stack pile = new Stack();
	BlocF bf, nouveauBloc, blocRetour;
	while (!fin) {
	    System.out.println("Je dois faire l'instruction "+instruction+" la pile est "+pile);
	    switch (instruction) {
	    case -2: // main, initialisation de x  10
		x = 10;
		instruction = -1;
		break;
	    case -1: // appel  f(x)
		bf = new BlocF(0,x); // quand calcul de f() termin, il faudra revenir en 0
		pile.push(bf); // transmission bloc d'activation
		instruction = 1; // saut vers premire instruction de f()
		break;
	    case 0:
		bf = (BlocF)(pile.pop()); // suppression bloc activation cr  l'appel
		System.out.println("Rsultat="+bf.valeurDeRetour);
		fin = true;
		break;
	    case 1: // premire instruction de f()
		// cas f(0)
		bf = (BlocF)(pile.peek());
		if (bf.parametreN==0) {
		    bf.valeurDeRetour = 1; // prpare la valeur de retour pour que l'appelant puisse la retrouver
		    instruction = bf.adresseDeRetour; // saut vers l'instruction qui suit l'appel, on retourne l on l'on nous a dit de retourner
		} else {
		    instruction = 2;
		}
		break;
	    case 2: // cas N pair
		bf = (BlocF)(pile.peek());
		if (bf.parametreN%2==0) {
		    nouveauBloc = new BlocF(3,bf.parametreN/2); // quand calcul de f() termin il faudra revenir en 3
		    pile.push(nouveauBloc); // transmission bloc activation
		    instruction = 1; // saut vers la premire instruction de f()
		} else {
		    instruction = 4;
		}
		break;
	    case 3: // retour de F(n/2)
		blocRetour = (BlocF)(pile.pop()); // on enlve le bloc transmis au moment de l'appel rcursif
		bf = (BlocF)(pile.peek()); // on rcupre les paramtres de cet appel ci
		bf.valeurDeRetour = bf.parametreN*blocRetour.valeurDeRetour; // on calcule n*f(n/2) qu'on range dans le bloc d'activation courant
		instruction = bf.adresseDeRetour; // on retourne l o l'on nous a dit de retourner
		break;
	    case 4: // cas N impair
		bf = (BlocF)(pile.peek());
		nouveauBloc = new BlocF(5,(bf.parametreN-1)/2); // quand calcul de f() termin il faudra revenir en 5
		pile.push(nouveauBloc); // transmission bloc d'activation
		instruction = 1; // saut vers la premire instruction de f()
		break;
	    case 5: // retour de F(n-1/2)
		blocRetour = (BlocF)(pile.pop()); // on enlve le bloc transmis au moment de l'appel rcursif
		bf = (BlocF)(pile.peek()); // on rcupre les paramtres de l'appel courant
		bf.valeurDeRetour = 1+blocRetour.valeurDeRetour; // on calcule 1+f((n-1)/2) qu'on range dans le bloc d'activation courant
		instruction = bf.adresseDeRetour; // on retourne l o l'on nous a dit de retourner
		break;
	    }
	}
    }
}